lib = File.expand_path('lib', __dir__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'rplidar/version'

Gem::Specification.new do |spec|
  spec.name          = 'rplidar'
  spec.version       = Rplidar::VERSION
  spec.authors       = ['Yury Kotlyarov']
  spec.email         = ['yura@brainhouse.ru']

  spec.summary       = 'Ruby implementation of SLAMTEK RPLIDAR driver.'
  spec.description   = 'Tested on SLAMTEK RPLIDAR A2M8'
  spec.homepage      = 'http://github.com/yura/rplidar'
  spec.license       = 'MIT'

  # Prevent pushing this gem to RubyGems.org. To allow pushes either set the
  # 'allowed_push_host' to allow pushing to a single host or delete this section
  # to allow pushing to any host.
  if spec.respond_to?(:metadata)
    spec.metadata['allowed_push_host'] = 'https://rubygems.org'
  else
    raise 'RubyGems 2.0 or newer is required to protect against ' \
      'public gem pushes.'
  end

  # Specify which files should be added to the gem when it is released.
  # The `git ls-files -z` loads the files in the RubyGem that have been
  # added into git.
  spec.files = Dir.chdir(File.expand_path(__dir__)) do
    `git ls-files -z`
      .split("\x0")
      .reject { |f| f.match(%r{^(test|features)/}) }
  end
  spec.bindir = 'exe'
  spec.executables = spec.files.grep(%r{^exe/}) { |f| File.basename(f) }
  spec.require_paths = ['lib']

  spec.add_dependency 'rubyserial', '~> 0.6'

  spec.add_development_dependency 'bundler', '~> 1.16'
  spec.add_development_dependency 'codecov'
  spec.add_development_dependency 'rake', '~> 10.0'
  spec.add_development_dependency 'rspec', '~> 3.0'
  spec.add_development_dependency 'rubocop-rspec'
end
